'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var readModelPropsNames = ['readModelName', 'resolverName', 'variables', 'isReactive'];

var compareReadModelProps = function compareReadModelProps(nextProps, prevProps) {
  return readModelPropsNames.reduce(function (acc, key) {
    return acc && JSON.stringify(nextProps[key]) === JSON.stringify(prevProps[key]);
  }, true);
};

var extractReadModelProps = function extractReadModelProps(props) {
  return readModelPropsNames.reduce(function (acc, key) {
    acc[key] = props[key];
    return acc;
  }, {});
};

var extractReadModelValues = function extractReadModelValues(props) {
  return readModelPropsNames.map(function (key) {
    return props[key];
  });
};

exports.default = function (mapStateToProps, mapDispatchToProps, mergeProps, options) {
  return function (Component) {
    var ConnectedComponent = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(Component);

    var ReadModelConnector = function (_React$PureComponent) {
      _inherits(ReadModelConnector, _React$PureComponent);

      function ReadModelConnector() {
        _classCallCheck(this, ReadModelConnector);

        return _possibleConstructorReturn(this, (ReadModelConnector.__proto__ || Object.getPrototypeOf(ReadModelConnector)).apply(this, arguments));
      }

      _createClass(ReadModelConnector, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var readModelProps = extractReadModelProps(mapStateToProps(this.context.store.getState(), nextProps));

          if (compareReadModelProps(readModelProps, this)) return;

          this.context.store.dispatch(_actions2.default.unsubscribeReadmodel(this.readModelName, this.resolverName));

          this.context.store.dispatch(_actions2.default.subscribeReadmodel.apply(_actions2.default, _toConsumableArray(extractReadModelValues(readModelProps))));

          Object.assign(this, readModelProps);
        }
      }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
          var readModelProps = extractReadModelProps(mapStateToProps(this.context.store.getState(), this.props));

          this.context.store.dispatch(_actions2.default.subscribeReadmodel.apply(_actions2.default, _toConsumableArray(extractReadModelValues(readModelProps))));

          Object.assign(this, readModelProps);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.context.store.dispatch(_actions2.default.unsubscribeReadmodel(this.readModelName, this.resolverName));
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(ConnectedComponent, this.props);
        }
      }]);

      return ReadModelConnector;
    }(_react2.default.PureComponent);

    ReadModelConnector.contextTypes = {
      store: _propTypes2.default.object.isRequired
    };

    return ReadModelConnector;
  };
};